extern string n1 = "  ";
extern int TimeControl = 0; //1 - , 0 - .
extern int StartTime = 7; 
extern int StopTime = 17;

extern string n2 = " ";
extern double Lots = 0.1; //  
extern int MaxLotNum = 1; //-   

extern string n3 = " -";
extern int TrailingStop = 10; //  

extern string n4 = " -";
extern int TrailingShag = 5;

extern string n5 = " ";
extern int BBUSize = 0; //   ,   -   .

extern string n6 = " -";
extern int StopLoss = 10; //  /   

extern string n7 = "-   ";
extern int BarsRange  = 1; //     

extern string n8 = "  ";
extern double StepFast = 0.01; 
extern double MaximumFast = 0.1;

extern string n9 = "  ";
extern double StepSlow = 0.001; 
extern double MaximumSlow = 0.01;

extern string n10 = "   ";
extern double Ur1 = 10;
extern string n11 = "   ";
extern double Ur2 = 10;

extern string n12 = " ";
extern int MagicNumber = 8800;

string Version = "My_Parabolic_1.0";
int nummodb,nummods;
int bars;
int err1;

int init() {

if (Digits==5) //   5-
{
TrailingStop=TrailingStop*10;
TrailingShag=TrailingShag*10;
StopLoss=StopLoss*10;
BBUSize=BBUSize*10;
}
   return (0);
}

int start()
  { //if(err1<0){Print("start()    ");return(-1);}
    if(bars!=Bars && ((TimeControl(StartTime,StopTime)!=1 && TimeControl==1) ||TimeControl==0))
    {bars=Bars;
     err1=ScalpParabolicPattern();
     }
 
 if(TrailingStop>0){err1=TrailingStop();}
 if(BBUSize>0){err1=BBU();}

   return(0);
  }
  

//+------------------------------------------------------------------+
int sarmax,sarmin,countbars,countbarv;
int ScalpParabolicPattern()
   {int err;double op,sl,tp,max,min,Ur50,Ur116;
   
//    .
int OpenOrdersCount = 0;
int MinOrder = OrdersTotal() - 1;
   for (int OrdersCount = MinOrder; OrdersCount >= 0; OrdersCount--) { 
      OrderSelect(OrdersCount, SELECT_BY_POS); 
      if (OrderMagicNumber() == MagicNumber && OrderSymbol() == Symbol())
         if (OrderType() < OP_BUYLIMIT) OpenOrdersCount++;
   }
   
   // 
   double sarslow=iSAR(NULL,0,StepSlow ,MaximumSlow,1);
   double fastsar=iSAR(NULL,0,StepFast,MaximumFast,1);
   double fastsarlast=iSAR(NULL,0,StepFast,MaximumFast,1);

   if(fastsar>Bid && sarslow<Bid){sarmax=1;}
   if(sarslow>Bid){sarmax=0;}

   if(fastsar<Bid && sarslow>Bid){sarmin=1;}
   if(sarslow<Bid){sarmin=0;}


   
   if(sarslow<Bid && fastsar<Bid && sarmax==1 )//           
   {sarmax=0;
    min=MaximumMinimum(0,BarsRange);   //  
    max=High[1];
   
    Ur50 =GetFiboUr(max,min,Ur1/100);// 50%  
    Ur116 =GetFiboUr(max,min,Ur2/100); // 116%  
 
   op=Ur50;  sl=min-StopLoss*Point;  tp=Ur116;
   if((Ask-op)<5*Point || (Ask-sl)<5*Point || (tp-Ask)<5*Point){return(0);}
   if (OpenOrdersCount < MaxLotNum) {err=OrderSend(Symbol(),OP_BUYLIMIT,Lots,ND(op),3,sl,tp,Version,MagicNumber,0,DodgerBlue);}
   if(err<0){Print("ScalpParabolicPattern()-      OP_BUYLIMIT.  op "+op+" sl "+sl+" tp "+tp+" "+GetLastError());return(-1);}
   nummodb=0;
   }
   
   if(sarslow>Bid && fastsar>Bid && sarmin==1 )//           
   {sarmin=0;
    max=MaximumMinimum(1,BarsRange);   //  
    min=Low[1];
   
    Ur50=GetFiboUr(min,max,Ur1/100);// 50%  
    Ur116=GetFiboUr(min,max,Ur2/100); // 116%  
 
   op=Ur50;  sl=max+StopLoss*Point;  tp=Ur116;
   if((op-Ask)<5*Point || (sl-Ask)<5*Point || (Ask-tp)<5*Point){return(0);}  
   if (OpenOrdersCount < MaxLotNum) {err=OrderSend(Symbol(),OP_SELLLIMIT,Lots,ND(op),3,sl,tp,Version,MagicNumber,0,Red);}
   if(err<0){Print("ScalpParabolicPattern()-      OP_SELLLIMIT.  op "+op+" sl "+sl+" tp "+tp+" "+GetLastError());return(-1);}
   nummods=0;
   
   }
   
   
   if(fastsar>Bid && ChLimitOrder(1)>0)
   {
   err=DeleteLimitOrder(1);
   }
 
   if(fastsar<Bid && ChLimitOrder(0)>0)
   {
   err=DeleteLimitOrder(0);
   }
 
return(0);
}

int DeleteLimitOrder(int type)
//   
{int i;int err;
  for(  i=1; i<=OrdersTotal(); i++)         
   {
      if(OrderSelect(i-1,SELECT_BY_POS)==true) 
       {                                   
         if(OrderType()==OP_BUYLIMIT && OrderMagicNumber() == MagicNumber && OrderSymbol()==Symbol() && type==1)
         { 
         err=OrderDelete(OrderTicket());
         }
          if(OrderType()==OP_SELLLIMIT && OrderMagicNumber() == MagicNumber && OrderSymbol()==Symbol() && type==0)
         { 
          err=OrderDelete(OrderTicket());
         }
       }
    }
return(err);
}

int ChLimitOrder(int type)
//     ,  BuyLimit  1,  SellLimit  0
{int i;
    for(  i=1; i<=OrdersTotal(); i++)         
   {
      if(OrderSelect(i-1,SELECT_BY_POS)==true) 
       {                                   
         if(OrderType()==OP_BUYLIMIT && OrderMagicNumber() == MagicNumber && OrderSymbol()==Symbol() && type==1)
         { 
          return(1);
         }
         if(OrderType()==OP_SELLLIMIT && OrderMagicNumber() == MagicNumber && OrderSymbol()==Symbol() && type==0)
         { 
          return(1);
         }
       }
    }
return(0);
}


double MaximumMinimum(int type,int BarsRange)
{//  /     (  Ur1    Ur2)
 int x=0,stop=0;double minmax;
  
  if(type==0)
   {
   while(stop==0)
    {
    minmax =Low[iLowest(NULL,0,MODE_LOW,BarsRange,x)];
    if(minmax>Low[iLowest(NULL,0,MODE_LOW,BarsRange,x+BarsRange)])
     {
      minmax =Low[iLowest(NULL,0,MODE_LOW,BarsRange,x+BarsRange)];
      x=x+BarsRange;
     }
     else {stop=1;return(minmax);}
    }//while(stop
   }//if(type
   
   if(type==1)
   {
   while(stop==0)
    {
    minmax =High[iHighest(NULL,0,MODE_HIGH,BarsRange,x)];
    if(minmax<High[iHighest(NULL,0,MODE_HIGH,BarsRange,x+BarsRange)])
      {
       minmax =High[iHighest(NULL,0,MODE_HIGH,BarsRange,x+BarsRange)];
       x=x+BarsRange;
       }
       else{stop=1;return(minmax);}
     }// while(sto
   }//if(type
return(0);          
}

double GetFiboUr(double high, double low, double ur)
{//     50%  Ur1  116%  Ur2                           
  double Fibo = ND(low + (high - low)*ur); return(Fibo);
return(0); 
}


int  TrailingStop()
{//   -
int i;bool err;double lastbid;

   for( i=1; i<=OrdersTotal(); i++)         
   {
      if(OrderSelect(i-1,SELECT_BY_POS)==true) 
       {   
        if(TrailingStop>0 && OrderType()==OP_BUY && OrderMagicNumber() == MagicNumber && OrderSymbol()==Symbol())  
        {                
         if(Bid-OrderOpenPrice()>=TrailingStop*Point && TrailingStop>0 && (Bid-Point*TrailingStop)>OrderStopLoss())
          {
           if(((Bid-Point*TrailingStop)-OrderStopLoss())>=TrailingShag*Point)
           {
            Print("");
            err=OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Aqua);
            if(err==false){return(-1);}
           }//if(Bid>=OrderStopLoss()
          }//if(Bid-OrderOpenPrice()
         }//if(BBUSize>0
        }//if(OrderSelect(i
            
       if(OrderSelect(i-1,SELECT_BY_POS)==true) 
       {
        if(OrderType()==OP_SELL && OrderMagicNumber() == MagicNumber && OrderSymbol()==Symbol() )  
        {        
         if(OrderOpenPrice()-Ask>=TrailingStop*Point && TrailingStop>0 && OrderStopLoss()>(Ask+TrailingStop*Point))
          {
           if((OrderStopLoss()-(Ask+TrailingStop*Point))>TrailingShag*Point)
           {
            Print("");
            err=OrderModify(OrderTicket(),OrderOpenPrice(),Ask+TrailingStop*Point,OrderTakeProfit(),0,DeepPink);
            if(err==false){return(-1);}
           }//if(Ask<=OrderStopLoss()
          }//if(OrderOpenPrice()
         }//if(BBUSize>0 
       }// if(OrderSelect
    }// for( i=1;
return(0);
}


int  BBU()
{//    
int i;bool err;
   for( i=1; i<=OrdersTotal(); i++)         
   {
      if(OrderSelect(i-1,SELECT_BY_POS)==true) 
       {   
        if(BBUSize>0 && OrderType()==OP_BUY && OrderMagicNumber() == MagicNumber && OrderSymbol()==Symbol() && OrderStopLoss()<OrderOpenPrice())  
        {                
         if(Bid-OrderOpenPrice()>=BBUSize*Point && BBUSize>0 )
          {
           Print("  ");
           err=OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+1*Point,OrderTakeProfit(),0,DarkOrchid);
           if(err==false){return(-1);}
          }//if(Bid-OrderOpenPrice()
         }//if(BBUSize>0
        }//if(OrderSelect(i
            
       if(OrderSelect(i-1,SELECT_BY_POS)==true) 
       {
        if(BBUSize>0 && OrderType()==OP_SELL && OrderMagicNumber() == MagicNumber &&  OrderSymbol()==Symbol() && (OrderStopLoss()>OrderOpenPrice() || OrderStopLoss()==0))  
        {        
         if(OrderOpenPrice()-Ask>=BBUSize*Point && BBUSize>0)
          {
           Print("  ");
           err=OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-1*Point,OrderTakeProfit(),0,Magenta);
           if(err==false){return(-1);}
          }//if(OrderOpenPrice()
         }//if(BBUSize>0 
       }// if(OrderSelect
    }// for( i=1;
return(0);
}


int TimeControl(int StartTime, int StopTime)
{//     .  TimeControl 1 - , 0 - 
   if (Hour()>=StartTime &&  Hour()<=StopTime) 
      { 
      return(0);
      }  
return(1);
}

//+--------------------------------------------------------------------------------------------------------------+
//|       double
//+--------------------------------------------------------------------------------------------------------------+

double ND(double Value) {
   return (NormalizeDouble(Value, Digits));
}